

{
    $Id: gplprog.pt,v 1.2 2002/09/07 15:40:47 peter Exp 2006/04/08 16:36:44 peter Exp $
    This file is part of KOL modifier for using with FPC.
    Copyright (c) 2006 by Phantom

    KOl for FPC optimiser 0.99.5b

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}
{$H+}

Program kolforfpc;

uses sysutils, strutils,classes;

Const pref = 'kol';

Var 
  //  Count : Longint ;
  filenames,renfiles: tstrings;
  i,j: integer;
  fileren,cleansrc: boolean;
  tmp: char;

Function checkforfileex: boolean;

Var 
  ok: boolean;
  i: integer;
Begin
  For i:=0 To filenames.count-1 Do
    Begin
      ok := true;
      If Not FileExists (filenames.strings[i]) Then ok := false;
    End;
  If ok=true Then checkforfileex := true
  Else checkforfileex := false;
End;

Function editfile(prefix:String;fname:String;ren:boolean): boolean;

Var 
  filecont: tstrings;
  buf,buf2: string;
  i: longint;
  j,position,len,skip: byte;
  edituses: boolean;
Begin
  edituses := true;
  filecont := tstringlist.create;
  filecont.loadfromfile(fname);
  For i:=0 To filecont.count-1 Do
    Begin
      buf := filecont.strings[i];
      If (lowercase(fname)='delphidef.inc') And (pos('{$define asm_version}',lowercase(buf))>0) Then
        Begin
          position := pos('{', buf);
          insert('.',buf,position+1);
        End;
      For j:=0 To renfiles.count-1 Do
        Begin
          //     uses  unit - "  uses"
          If (pos('uses', lowercase(buf))>0) Or (pos('unit ', lowercase(buf))>0)  Then edituses := true;
          // edituses:=false ("  uses" ),     var, begin  ..
          If (pos('var', lowercase(buf))>0) Or (pos('const', lowercase(buf))>0)Or (pos('resourcestring', lowercase(buf))>0)Or (pos('begin', lowercase(buf))>0)Or(pos('end of uses', lowercase(buf))>0 )Then edituses := false;
          //  edituses=true .. "  uses" -      renfiles.strings[j], renfiles.strings[j],    (  )
          If edituses=true Then
            Begin
              buf2 := renfiles.strings[j];
              position := pos('.', buf2);
              len := length(buf2)-position;
              delete(buf2,position,len+1);
              skip := 0;
              Repeat
                inc(skip);
                position := npos(lowercase(buf2),lowercase(buf),skip);
                If (position>0) Then
                  Begin
                    delete(buf, position, length(buf2));
                    insert(prefix+buf2, buf, position);
                  End
              Until position=0;
            End
          Else
            //  edituses=false ..   "  uses" -      renfiles.strings[j], renfiles.strings[j],   
            Begin
              buf2 := renfiles.strings[j];
              position := pos('.', buf2);
              len := length(buf2)-position;
              delete(buf2,position+1,len);
              skip := 0;
              Repeat
                inc(skip);
                position := npos(lowercase(buf2),lowercase(buf),skip);
                If (position>0) Then
                  Begin
                    delete(buf, position, length(buf2));
                    insert(prefix+buf2, buf, position);


                  End

              Until position=0;

            End;
        End;
      filecont.strings[i] := buf;
    End;


  If ren Then
    Begin
      filecont.savetofile('kolforfpc\'+prefix+fname);
    End
  Else filecont.savetofile('kolforfpc\'+fname);

  filecont.free;
End;

Procedure cleanup;

Var 
  i,j: byte;
Begin
  writeln('Cleaning up...');
  For i:=0 To filenames.count-1 Do
    For j:=0 To renfiles.count-1 Do
      Begin
        If filenames.strings[i]=renfiles.strings[j] Then
          Begin
            If pos('.txt',filenames.strings[i])=0 Then deletefile('kolforfpc\'+pref+filenames.strings[i]);
          End
        Else
          Begin
            If pos('.txt',filenames.strings[i])=0 Then deletefile('kolforfpc\'+filenames.strings[i]);

          End;
      End;
End;

Procedure writeinfo;

Var 
  f: text;
Begin
  assign{file}(f,'kolmodinfo.txt');
     rewrite(f);
     append(f);
     writeln(f,' KOL   '+GetCurrentDir+'\kolforfpc');
     writeln(f,' ');
     writeln(f,'     ,');
     writeln(f,'    FPC '' fpc.cfg'',     -Fu(,   ).');
     writeln(f,' FuC      ,  : -FuC:\kolfpc.');
     writeln(f,' ');
     writeln(f,'  KOL      FPC!');
     flush(f);
     close{file}(f);
  executeprocess('notepad.exe','kolmodinfo.txt');
End;

Begin
  writeln('Phantom''s KOL modifier for using with FPC. Vertion 0.99.5b');

  If (fileexists('needfiles.txt') And fileexists('renfiles.txt')) Then
    Begin
      filenames := tstringlist.create;
      filenames.loadfromfile('needfiles.txt');
      renfiles := tstringlist.create;
      renfiles.loadfromfile('renfiles.txt');

      If checkforfileex Then
        Begin
          Writeln ( ' All is well , all files seem to exist . Modifying them ... ' );
          Writeln ( '  , ,  䠩 .   ... ' );
          For i:=0 To filenames.count-1 Do
            Begin
              fileren := false;
              If directoryexists('kolforfpc')=false Then createdir('kolforfpc');
              For j:=0 To renfiles.count-1 Do
                Begin
                  If (lowercase(filenames.strings[i]))=(lowercase(renfiles.strings[j])) Then
                    Begin
                      fileren := true;
                    End;
                End;
              editfile(pref,filenames.strings[i],fileren);
            End;
          executeprocess('fpc.exe','-Mdelphi -Rintel -OG2p3 -Xs -XX -CX -Sg kolforfpc\kol.pas');
          writeln;

          writeln('Would you like to delete a modified sources? Y/N ');
          write('  㤠  室? Y/N ');
          Repeat
            readln(tmp);
          Until (tmp='Y') Or (tmp='y') Or (tmp='N') Or (tmp='n');
          Case tmp Of
            'Y', 'y': cleansrc := true;
            'N', 'n': cleansrc := false;
          End;
          If cleansrc Then cleanup;
          writeinfo;

        End
      Else
        Begin
          writeln('Error! Some files does not exist. ');
          write('訡!  䠩  . ');
          readln;
        End;
      renfiles.free;
      filenames.free;
    End
  Else
    Begin
      writeln('Error! A file needfiles.txt or renfiles.txt does not exist. ');
      write('訡!  needfiles.txt  renfiles.txt  . ');
      readln;
    End;
End.
